<!DOCTYPE html>
<html lang="en">

<head>
  
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title> Home</title>

  <script src="https://cdn.jsdelivr.net/gh/google/code-prettify@master/loader/run_prettify.js"></script>
  <script src="https://unpkg.com/@babel/standalone/babel.min.js"></script>
  <script src="./build/entry.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <!--[if lt IE 9]>
    <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
  <![endif]-->
  <link href="https://fonts.googleapis.com/css?family=Roboto:100,400,700|Inconsolata,700" rel="stylesheet">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.3/css/all.css" integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/" crossorigin="anonymous">
  <link type="text/css" rel="stylesheet" href="https://jmblog.github.io/color-themes-for-google-code-prettify/themes/tomorrow-night.min.css">
  <link type="text/css" rel="stylesheet" href="styles/app.min.css">
  <link type="text/css" rel="stylesheet" href="styles/iframe.css">
  <link type="text/css" rel="stylesheet" href="">
  <script async defer src="https://buttons.github.io/buttons.js"></script>

  
</head>



<body class="layout small-header">
    <div id="stickyNavbarOverlay"></div>
    

<div class="top-nav">
    <div class="inner">
        <a id="hamburger" role="button" class="navbar-burger" aria-label="menu" aria-expanded="false">
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
        </a>
        <div class="logo">
            
            
        </div>
        <div class="menu">
            
            <div class="navigation">
                <a
                    href="index.html"
                    class="link"
                >
                    API Documentation
                </a>
                
                
                
            </div>
        </div>
    </div>
</div>
    <div id="main">
        <div
            class="sidebar "
            id="sidebarNav"
        >
            
            <nav>
                
                    <h2><a href="index.html">Documentation</a></h2><div class="category"><h3>Classes</h3><ul><li><a href="Board.html">Board</a></li><li><a href="Task.html">Task</a></li></ul><h3>Global</h3><ul><li><a href="global.html#status">status</a></li></ul></div>
                
            </nav>
        </div>
        <div class="core" id="main-content-wrapper">
            <div class="content">
                <header class="page-title">
                    <p></p>
                    <h1>Home</h1>
                </header>
                



    


    <h3> </h3>










    




    <section>
        <article><img src="https://webassets.telerikacademy.com/images/default-source/logos/telerik-academy.svg" alt="logo" width="300px" style="margin-top: 20px;"/>
<h1>Boardr - Task organizing system</h1>
<h3>1. Description</h3>
<p>In its complete form, <em>Boardr</em> will be a system for creating, updating, organizing, and managing tasks, issues, and notes. The application will be built <strong>using the best practices for object-oriented design</strong> (OOD) and <strong>object-oriented programming</strong> (OOP).</p>
<br>
<h3>2. Project information</h3>
<ul>
<li>Language and version: <strong>JavaScript ES2020</strong></li>
<li>Platform and version: <strong>Node 14.0+</strong></li>
<li>Core Packages: <strong>ESLint</strong>, <strong>JSDoc</strong></li>
</ul>
<br>
<h3>3. Goals</h3>
<p>Today, we will lay down the foundations of this system. The <strong>goal</strong> is to design the two main <strong>classes</strong> of the system - the <code>Board</code> class and the <code>Task</code> class. We will use and improve upon these classes later in the course. In addition, you will have to document the code you wrote using JSDoc. During this session, you will exercise:</p>
<ul>
<li>Working with classes - writing classes and creating instances of those classes.</li>
<li>Modeling classes using <code>fields</code> (state) and <code>methods</code> (behavior).</li>
<li>Protecting the state using validations.</li>
<li>Writing basic code documentation using <strong>JSDoc</strong>.</li>
</ul>
<br>
<h3>4. Setup</h3>
<p>To get the project up and running, follow these steps:</p>
<ol>
<li>
<p>Go inside the <code>Template</code> folder.</p>
</li>
<li>
<p>Run <code>npm install</code> to restore all dependencies.</p>
</li>
<li>
<p>After that, there are a few scripts you can run:</p>
<ul>
<li><code>npm run start</code> - Runs the <code>src/main.js</code> file.</li>
<li><code>npm run lint</code> - Lints the code inside the <code>src</code> folder using <strong>ESLint</strong>.</li>
<li><code>npm run docs</code> - Generates documentation in a <code>docs</code> folder using <strong>JSDoc</strong>.</li>
</ul>
</li>
</ol>
<br>
<h3>5. Getting started</h3>
<p>The first step is to read the <strong>whole task description</strong>. This will give you an overall idea what is going on and what is expected of you. The next step is to get familiar with the <strong>provided code</strong>. There are a few key things you can do:</p>
<ul>
<li>Get familiar with the overall project - what config files exist, what are their settings, what folders are there and what files are there in those folders.</li>
<li>The code is usually stored in a <code>src</code> folder. There could be other folders, such as <code>docs</code> for documentation, usually generated from a script (like jsdoc).</li>
<li>You can also check the dependency graph, which will give you an overall idea how different parts of the code are connected, but most importantly, in what order to read the code itself.
<img src="./Dependencies.svg" alt="Dependency graph"></li>
<li>Start with the entry point (usually the <code>main.js</code> file) and slowly review the code written inside. Then move on to the imported files, read them and move on to their dependencies and etc.</li>
<li>Some of the provided code will already be documented using the JSDoc syntax. This will give you a good idea what that code does and how you can use it to complete the task.</li>
<li>You can also find comments, hints or even links to resources you should check out to gain further understanding of a specific part of the code or a new concept that is introduced there.</li>
</ul>
<br>
<h3>6. The <code>Task</code> class</h3>
<p>After you have gotten yourself familiar with the project, it's time to work on your first task. Write a class that will be used to create tasks. The objects created from that class should have the following state:</p>
<ul>
<li><code>name</code> - It should never be <strong>null, undefined or an empty string</strong>, its length should be between <strong>6 and 20 characters</strong></li>
<li><code>dueDate</code> - The date of the deadline. Think of what validation will be needed here.</li>
<li><code>status</code> - The task's status should be one of the three <code>TODO</code>, <code>IN_PROGRESS</code>, or <code>DONE</code>. Think of what is the best way to represent the value and its type.</li>
</ul>
<p>The following methods should be implemented as well:</p>
<ul>
<li><code>changeName(value)</code> - It should set the <code>name</code> to the passed <code>value</code>, only if that <code>value</code> is valid!</li>
<li><code>changeDueDate(value)</code> - It should set the <code>dueDate</code> to the passed <code>value</code>, only if that <code>value</code> is valid!</li>
<li><code>reset()</code> - It should set the status of the task to <code>TODO</code></li>
<li><code>advance()</code> - It should set the status of the task to <code>IN_PROGRESS</code></li>
<li><code>complete()</code> - It should set the status of the task to <code>DONE</code></li>
</ul>
<br>
<h4>6.1 Using the Task class</h4>
<p>Now, when you have the <code>Task</code> class implemented try to create a few instances of the class inside the <code>main.js</code> file:</p>
<pre class="prettyprint source lang-javascript"><code>const task1 = new Task(&quot;Validate fields&quot;, new Date(&quot;2022/09/03&quot;));
const task2 = new Task(&quot;Write unit tests&quot;, new Date(&quot;2022/09/04&quot;));
const task3 = new Task(&quot;Remove console.log&quot;, new Date(&quot;2022/09/05&quot;));
</code></pre>
<p>What happens when you put the tasks in an array and try to print the array?</p>
<pre class="prettyprint source lang-javascript"><code>const tasks = [task1, task2, task3];
console.log(`${tasks}`);
</code></pre>
<p>In some cases the compiler will try to convert the array to string and you might see something like this:</p>
<pre class="prettyprint source lang-json"><code>[object Object],[object Object],[object Object]
</code></pre>
<p>Remember what are the two methods common to every JavaScript object and type (except for <code>null</code>, <code>undefined</code>, and objects created with <code>Object.create(null)</code>)</p>
<ul>
<li><code>toString()</code> and <code>valueOf()</code>.</li>
</ul>
<p>The built-in <code>toString</code> method of the <code>Array</code> class will return a string with the values of the array converted to strings on their own, separated with comma. In order to force the array to be printed this way you can use the method explicitly:</p>
<pre class="prettyprint source lang-typescript"><code>console.log(tasks.toString());
</code></pre>
<br>
<h4>6.2 Extending the Task class</h4>
<p>Because this format is not very readable, think of a way to <strong>override</strong> the <code>toString()</code> method of the task so that it returns a more meaningful string, for example:</p>
<pre class="prettyprint source lang-text"><code>Name: Update naming
Status: Todo
Due: 9/4/2022 12:00:00 AM
</code></pre>
<details>
  <summary>Hint: How to change the behavior of toString()?</summary>
<p>Create a new method called <code>toString()</code> inside the Task class. Whatever you write inside that method will be executed instead of the default <code>toString()</code> that comes from JavaScript itself.</p>
</details>
<details>
  <summary>Hint: How to format the date?</summary>
Option 1: Explore native <a href="https://www.freecodecamp.org/news/how-to-format-dates-in-javascript/" target="_blank|">date formatting options</a>   
<p>Option 2: Use an external library.</p>
<p>You can use <code>moment.js</code> to format the date to your liking. Install <code>moment.js</code> using <code>npm install moment</code>, then import it inside the <code>task.js</code> file using <code>import moment from 'moment';</code>.</p>
</details>
<br>
<h3>7. The <code>Board</code> class</h3>
<p>The <code>Board</code> class will hold all the different tasks we create. Its role will be to <em>contain</em> the tasks and expose some functionality to manage them.</p>
<p>You need to implement the different fields and methods of the class:</p>
<ul>
<li><code>tasks</code> - This field is an array that holds <code>Task</code> objects.</li>
</ul>
<p>The board should expose the proper methods which allow for tasks to be added or removed from the board. Think of the needed checks and validation:</p>
<ul>
<li><code>add(task)</code> - It should add a task to the list of tasks in the board. A single task can be added only once!</li>
<li><code>remove(task)</code> - It should remove a task from the list of tasks. The board should not allow for a task to be removed if it's not in the list!</li>
</ul>
<br>
<h4>7.1 Implementing  <code>toString()</code></h4>
<p>You need to override the <code>toString</code> method of the board, just like you did for the Task class. it should return a string that contains useful information about the object, example of such return is as follows:</p>
<h4>Empty board</h4>
<pre class="prettyprint source lang-text"><code>---Task Board---

Tasks:

No tasks at the moment.
</code></pre>
<h4>Board with some tasks</h4>
<pre class="prettyprint source lang-text"><code>---Task Board---

Tasks:

Name: Validate fields
Status: InProgress
Due: 9/3/2022 12:00:00 AM
--------
Name: Write unit tests
Status: Done
Due: 9/4/2022 12:00:00 AM
--------
Name: Remove console.log
Status: Todo
Due: 9/5/2022 12:00:00 AM
</code></pre>
<br>
<h3>8. Document the code</h3>
<p>Document the code using the JSDoc syntax. Write a short description of what each <strong>field</strong> and <strong>method</strong> does. For example:</p>
<pre class="prettyprint source lang-javascript"><code>/** Adds a new task to the board, only if it is valid.*/
add(task) {
  ....
}
</code></pre>
<p>Then proceed to generate the <code>docs</code> folder using <code>npm run docs</code>.</p>
<br>
<h3>9. Testing the <code>Board</code> and the <code>Task</code> classes</h3>
<p>You can paste the following sample code inside the <code>main.js</code> file. Running this code should produce the output shown below. Even if the outo:</p>
<pre class="prettyprint source lang-javascript"><code>// Print a colorful line on the console
const newline = () => console.log(&quot;\n \x1b[35m* * * * *\x1b[37m \n&quot;);

const board = new Board();
const anotherBoard = new Board();

const task1 = new Task('Validate fields', new Date(&quot;2022/09/03'));
const task2 = new Task('Write unit tests', new Date('2022/09/04'));
const task3 = new Task('Remove console.log', new Date('2022/09/05'));

console.log(board.toString());

newline();

board.add(task1);
board.add(task2);
board.add(task3);

task1.advance();
task2.complete();

console.log(board.toString());

newline();

board.remove(task3);

console.log(task1.toString());

newline();

console.log('board.itemCount:', board._tasks.length);
</code></pre>
<p>Sample output text:</p>
<pre class="prettyprint source lang-text"><code>No tasks at the moment.

 * * * * *

---Task Board---

Tasks:

Name: Validate fields
Status: In progress
Due: 9/3/2022 12:00:00 AM
--------
Name: Write unit tests
Status: Done
Due: 9/4/2022 12:00:00 AM
--------
Name: Remove console.log
Status: Todo
Due: 9/5/2022 12:00:00 AM

 * * * * *

Name: Validate fields
Status: In progress
Due: 9/3/2022 12:00:00 AM

 * * * * *

board.itemCount: 2
</code></pre></article>
    </section>






            </div>
            
            <footer class="footer">
                <div class="content has-text-centered">
                    <p>Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a></p>
                    <p class="sidebar-created-by">
                        <a href="https://github.com/SoftwareBrothers/better-docs" target="_blank">BetterDocs theme</a> provided with <i class="fas fa-heart"></i> by 
                        <a href="http://softwarebrothers.co" target="_blank">SoftwareBrothers - JavaScript Development Agency</a>
                    </p>
                </div>
            </footer>
            
        </div>
        <div id="side-nav" class="side-nav">
        </div>
    </div>
<script src="scripts/app.min.js"></script>
<script>PR.prettyPrint();</script>
<script src="scripts/linenumber.js"> </script>

</body>
</html>